<?php

/*****************************************/
/* Grab Required Includes				 */
/*****************************************/
require dirname ( __FILE__ ) . '/../../../dbconnect.php';
require ROOTDIR . '/includes/functions.php';
require ROOTDIR . '/includes/registrarfunctions.php';

/*****************************************/
/* Transaction Processor Function		 */
/*****************************************/
function transactionProcessor($call)
{
	# Set CURL Options
    $options = array(
        CURLOPT_RETURNTRANSFER => true,     // return web page
        CURLOPT_HEADER         => false,    // don't return headers
        CURLOPT_USERAGENT      => "Namesilo Domain Sync V0.5(BETA)", // who am i
    );
	
	# Initialize CURL
    $ch      = curl_init($call);
	# Import CURL options array
    curl_setopt_array($ch, $options);
	# Execute and store response
    $content = curl_exec( $ch );
	# Process any CURL errors
	$curl_err = false;
	if (curl_error ( $ch )) {
		$curl_err = 'CURL Error: ' . curl_errno ( $ch ) . ' - ' . curl_error ( $ch );
		exit ( 'CURL Error: ' . curl_errno ( $ch ) . ' - ' . curl_error ( $ch ) );
	}
	# Log error(s)
	if ($curl_err) { $cronreport .= "Error connecting to API: $curl_err"; }	
    curl_close( $ch );
	# Process XML result
	$xml = new SimpleXMLElement($content);
	$result ["expiry"] = (string) $xml->reply->expires;
	$result ["status"] = (string) $xml->reply->status;
	# Return result
	return $result;
}

/*****************************************/
/* Get Registrar Config Options			 */
/*****************************************/
$params = getregistrarconfigoptions('namesilo');

/*****************************************/
/* Define Test Mode						 */
/*****************************************/
define ('TEST_MODE', $params ["Test_Mode"]);

/*****************************************/
/* Define Sync Due Date					 */
/*****************************************/
define ('SNYC_NEXT_DUE_DATE', $params ["Sync_Next_Due_Date"]);

/*****************************************/
/* Define API Servers					 */
/*****************************************/
define ('LIVE_API_SERVER', 'https://www.namesilo.com');
define ('TEST_API_SERVER', 'http://sandbox.namesilo.com');

/*****************************************/
/* Define API Keys						 */
/*****************************************/
define ('TEST_API_KEY', $params['Sandbox_API_Key']);
define ('LIVE_API_KEY', $params['Live_API_Key']);

/*****************************************/
/* Check Test Mode and Assign Variables	 */
/*****************************************/
# Set appropriate API server
$apiServerUrl = (TEST_MODE == "on") ? TEST_API_SERVER : LIVE_API_SERVER;
# Set appropriate API key
$apiKey = (TEST_MODE == "on") ? TEST_API_KEY : LIVE_API_KEY;

/*****************************************/
/* Implement Updates					 */
/*****************************************/
# Start cron report
$cronreport = 'Namesilo Domain Sync Report<br>
---------------------------------------------------<br>
';
# Query WHMCS for a list of domains using Namesilo
$queryresult = select_query ( "tbldomains", "domain", "registrar='namesilo' AND (status='Pending Transfer' OR status='Active')" );
while ( $data = mysql_fetch_array ( $queryresult ) ) {
	# Clean data
	$domainname = trim ( strtolower ( $data ['domain'] ) );
	# Build API call 
	$result = transactionProcessor($apiServerUrl . "/api/getDomainInfo?version=1&type=xml&key=$apiKey&domain=$domainname");
	# Process results
	if (!is_null($result["expiry"])) {
		$expirydate = $result ["expiry"];
		$status = $result ["status"];
		if ($status == 'Active') {
			update_query ( "tbldomains", array ("status" => "Active" ), array ("domain" => $domainname ) );
		}
		if ($expirydate) {
			update_query ( "tbldomains", array ("expirydate" => $expirydate ), array ("domain" => $domainname ) );
			if (SNYC_NEXT_DUE_DATE == 'on') {
				update_query ( "tbldomains", array ("nextduedate" => $expirydate ), array ("domain" => $domainname ) );
			}
			$cronreport .= '' . 'Updated ' . $domainname . ' expiry to ' . frommysqldate ( $expirydate ) . '<br>';
		}
	} else {
		$cronreport .= '' . 'ERROR: ' . $domainname . ' -  Domain does not appear in the account at Namesilo<br>';
	}
}
/*****************************************/
/* Log System Activity					 */
/*****************************************/
logactivity ( 'Namesilo Domain Sync Run' );

/*****************************************/
/* Send Cron Report						 */
/*****************************************/
sendadminnotification ( 'system', 'Namesilo Domain Syncronization Report', $cronreport );
?>
